!--------------------------------------------------------------------
!>This program converts YYYY-JJJ formatted date to YYYY-MM-DD
!--------------------------------------------------------------------

program julian2dy_pro

implicit none

integer :: year,jdy
integer :: mth,dy
integer :: i,lpyrck
integer,dimension(12) :: jday

!write(*,*) "Enter year (4-digit integer)"
read(*,*) year
!write(*,*) "Enter julian day (up to 3-digit integer)"
read(*,*) jdy
!print *, 'Date entered:'
!print *, year,jdy

lpyrck = mod(float(year),4.0)
!print *, lpyrck

if (lpyrck == 0) then
! print *, 'year is a leap year'
 jday(1) = 1
 jday(2) = 32 
 jday(3) = 61
 jday(4) = 92
 jday(5) = 122
 jday(6) = 153
 jday(7) = 183
 jday(8) = 214
 jday(9) = 245
 jday(10) = 275
 jday(11) = 306
 jday(12) = 336

 do i=1,12
  mth = i
  if (jdy < jday(i)) then
   mth = i-1
   exit
  endif
 enddo
 dy = jdy-jday(mth)+1
! print *, 'returned day:'
 print *, dy

endif

if (lpyrck /= 0) then
! print *, 'year is not a leap year'
 jday(1) = 1
 jday(2) = 32 
 jday(3) = 60
 jday(4) = 91
 jday(5) = 121
 jday(6) = 152
 jday(7) = 182
 jday(8) = 213
 jday(9) = 244
 jday(10) = 274
 jday(11) = 305
 jday(12) = 335

 do i=1,12
  mth = i
  if (jdy < jday(i)) then
   mth = i-1
   exit
  endif
 enddo
 dy = jdy-jday(mth)+1
! print *, 'returned day:'
 print *, dy

endif

end program julian2dy_pro
